//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unniticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef UNICODE
#define UNICODE
#endif

#ifndef WINDOWS
#define WINDOWS
#include <windows.h>
#endif

#ifndef WINSOCK2
#define WINSOCK2
#include<winsock2.h>
#endif

#ifndef WINPROC
#define WINPROC
#include <WinProc.h>
#endif

#ifndef WSTRING
#define WSTRING
#include <wString.h>
#endif

#ifndef FILESTR
#define FILESTR
#include "filestr.h"
#endif



typedef char custom[5];

struct Pvoidl
{
    Pvoidl *Left;
    LPVOID element;
    custom cust;
    Pvoidl *Right;
};

class DynamicList
{

private:

    Pvoidl *Curr,*First,*End;
    unsigned long Count;
    bool OnAccess;
    void GoToBegin();
    void GoToEnd();
    void GoToPos(unsigned long Index);
    void Delete(const unsigned long Index);
public:
    void Add(LPVOID element,custom *c);
    void ClearList();
    void DeleteLine(const unsigned long indx);
    bool IsInList(LPVOID element);
    bool IsInListQuick(LPVOID element);
    int GetCount();
    LPVOID GetCustom(int pos,custom &c);
    LPVOID &operator [](unsigned long Index);
    DynamicList &operator =(DynamicList &S);
    DynamicList &operator +(DynamicList &S);

DynamicList();
~DynamicList();

};



//code

    void DynamicList::Add(LPVOID element,custom *c)
{

    while(OnAccess==true){Sleep(1);};
    OnAccess=true;

    if (Count==0)
    {
      GoToBegin();
      Curr->element=element;
       if (c!=NULL)
    CopyMemoryM(Curr->cust,(*c),5);
        Count++;
        //Current++;
//        SetLength();
    }else
    {
    GoToEnd();
    Pvoidl *N=new Pvoidl;
    Curr->Right=N;
    N->Left=Curr;
    N->Right=NULL;
    N->element=element;
    if (c!=NULL)
    CopyMemoryM(N->cust,(*c),5);
    Curr=N;
    Count++;
    End=Curr;
    }
    OnAccess=false;
};

LPVOID DynamicList::GetCustom(int pos,custom &c)
{


    while(OnAccess==true){Sleep(1);};
    OnAccess=true;
    GoToPos(pos);
    OnAccess=false;

    CopyMemoryM(c,Curr->cust,5);
    return Curr->element;



}

void DynamicList::DeleteLine(const unsigned long indx)
{
  while(OnAccess==true){Sleep(1);};
    OnAccess=true;
 Delete(indx);
 OnAccess=false;

}

bool DynamicList::IsInList(LPVOID element)
{
     bool ret=false;

     while(OnAccess==true){Sleep(1);};
     OnAccess=true;

     Pvoidl *temp=Curr;
     GoToBegin();
    for (ULONG i=0;i<Count;i++)
        {

            if (Curr->element==element)
            {
                ret=true;
                break;
            }

             if (Curr->Right!=NULL)
            {
                Curr=Curr->Right;
            }
        }
     Curr=temp;
     OnAccess=false;
     return ret;
}

bool DynamicList::IsInListQuick(LPVOID element)
{
     bool ret=false;

     Pvoidl *en=Curr;
     if (Curr==NULL) return false;
     while (OnAccess==true){Sleep(1);};
    // OnAccess==true;
   while (true)
        {

            if (Curr->element==element)
            {
                ret=true;
                break;
            }

             if (en->Left!=NULL)
            {
                en=en->Left;
            } else return ret;
        }
   // OnAccess==false;
     return ret;
}

void DynamicList::ClearList()
{
//     while(OnAccess==true){Sleep(1);};
    OnAccess=true;
    unsigned int C=Count+1;
  for (unsigned int i=1;i<C;i++)
    Delete(0);

   OnAccess=false;
};

int DynamicList::GetCount()
{
return Count;

};


    void DynamicList::GoToBegin()
{
Curr=First;
};


    void DynamicList::GoToEnd()
{
Curr=End;
};

    void DynamicList::GoToPos(unsigned long Index)
        {
        try
        {
        if (Index<0) throw -1;
        else
        if (Index>(Count-1)) throw -2;
         GoToBegin();
        // Current=0;
                if ((Count>1)&&(Index>0))
                {
                    for (unsigned long i=1;i<Index+1;i++)//+++++++++++++++++++++++++++++++++++++++++++
                    {

                        if (Curr->Right!=NULL)
                        {
                            Curr=Curr->Right;
              //          Current++;
                        }
                    }
                }
            }//try

            catch(...)
            {
               Smessage(L"DynamicList Index Error At:",IntToStr(Index));
            }
        };
 LPVOID &DynamicList::operator [](unsigned long Index)
{
    while(OnAccess==true){Sleep(1);};
    OnAccess=true;
    GoToPos(Index);
    OnAccess=false;
    return Curr->element;

};


    DynamicList &DynamicList::operator =(DynamicList &S)
{
     while(OnAccess==true){Sleep(1);};
    OnAccess=true;

    ClearList();
  for(int i=0;i<S.GetCount();i++)
  {
      custom c;
      S.GetCustom(i,c);
       Add(S[i],&c);
  }


  OnAccess=false;
 return *this;
};

    DynamicList &DynamicList::operator +(DynamicList &S)
{
    while(OnAccess==true){Sleep(1);};
    OnAccess=true;

     for(int i=0;i<S.GetCount();i++)
     {
          custom c;
          S.GetCustom(i,c);
          Add(S[i],&c);
     }

    OnAccess=false;
    return *this;
};


void DynamicList::Delete(const unsigned long Index)
{
    GoToPos(Index);
    Pvoidl *del,*left,*right;
if (Curr!=NULL)
{
    if (Index==0)//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
GoToBegin();
if (Count!=1)
{
del=Curr;
GoToPos(Index+1);
    First=Curr;
Curr->Left=NULL;

Count--;
GoToBegin();
delete del->cust;
delete del;
}//if count!=1
else
{
  GoToBegin();
Count--;
}
}

else
if ((Index+1)<Count)//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
del=Curr;
GoToPos(Index-1);
left=Curr;
GoToPos(Index+1);
right=Curr;
left->Right=right;
right->Left=left;

delete del->cust;
delete del;
Count--;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    GoToBegin();
}//if <Count
else

if ((Index+1)==Count)//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{

if (Count!=1)
{
del=Curr;
GoToPos(Index-1);
left=Curr;

left->Right=NULL;//dixnei NULL
delete del->cust;
delete del;
End=left;
Count--;
//Current=Index;
    GoToBegin();
}
}//if ==Count

}//if NULL

};




DynamicList::DynamicList()
{
   Curr=new Pvoidl;
   Curr->Left=NULL;
   Curr->Right=NULL;
    First=Curr;
    End=Curr;
   Count=0;
   OnAccess=false;
};


DynamicList::~DynamicList()
{
    if (First!=NULL)
    {
  unsigned int C=Count+1;
  for (unsigned int i=1;i<C;i++)
    Delete(0);
   GoToBegin();
   delete Curr;
   First=NULL;
  }

};










