//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unnoticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef WINDOWS
#define WINDOWS
#include<windows.h>
#endif

#ifndef WINPROC
#define WINPROC
#include <WinProc.h>
#endif

enum val_type{rbinary=REG_BINARY,rstring=REG_SZ,rnumeric=REG_DWORD};

bool KeyExistsreg(HKEY root, const WCHAR *key);
bool ValueExistreg(HKEY root,const WCHAR *key,const WCHAR *ValueName);
WCHAR *ReadValuereg(HKEY root, const WCHAR *key,const WCHAR *ValueName);
bool CreateKeyreg(HKEY root, const WCHAR *subkey, const WCHAR *key);
bool CreateValuereg(HKEY root, const WCHAR *key,const WCHAR *ValueName, const WCHAR *Value,val_type ValueType,long ValueLen);
bool DeleteValuereg(HKEY root,const WCHAR *key, const WCHAR *ValueName);

//code


bool KeyExistsreg(HKEY root,const WCHAR *key)
{
     HKEY hkey=0;
     long error=RegOpenKeyEx(root,key,0,KEY_READ,&hkey);
if (error==ERROR_SUCCESS)
return true;
else
return false;

}

bool ValueExistreg(HKEY root, const WCHAR *key, const WCHAR *ValueName)
{

     HKEY hkey;

     if (RegOpenKeyEx(root,key,0,KEY_READ,&hkey)!=ERROR_SUCCESS)
     return false;


  if( RegQueryValueEx(hkey,ValueName,NULL,NULL,NULL,NULL) == ERROR_SUCCESS)
  return true;
  else
  return false;

}

WCHAR *ReadValuereg(HKEY root, const WCHAR *key, const WCHAR *ValueName)
{
     HKEY hkey;
     DWORD size;

     long error=RegOpenKeyEx(root,key,0,KEY_READ,&hkey);
     if (error!=ERROR_SUCCESS)
     {
        WCHAR * er=new WCHAR[10];
        CopyStr(er,L"$$error$$",10);
        return er;
     }

     BYTE * data;

     if (RegQueryValueEx(hkey,ValueName,NULL,NULL,NULL,&size)==ERROR_SUCCESS)
     {
           data=new BYTE[size];
           data[size]=0;
     } else
     {
        WCHAR * er=new WCHAR[10];
        CopyStr(er,L"$$error$$",10);
        return er;
     }


if (RegQueryValueEx(hkey,ValueName,NULL,NULL,data,&size)==ERROR_SUCCESS)
   return (WCHAR*)data;
   else
   {
        WCHAR * er=new WCHAR[10];
        CopyStr(er,L"$$error$$",10);
        return er;
   }

}


bool CreateKeyreg(HKEY root, const WCHAR* subkey, const WCHAR *key)
{
     HKEY hkey;
     HKEY newkey;
     DWORD res;

     if (RegOpenKeyEx(root,subkey,0,KEY_READ,&hkey)!=ERROR_SUCCESS)
     return false;

    if (RegCreateKeyEx(hkey,key,0,NULL,REG_OPTION_NON_VOLATILE,KEY_CREATE_SUB_KEY,
                       NULL,&newkey,&res)==ERROR_SUCCESS)
   return true;
   else
   return false;

}



bool CreateValuereg(HKEY root, const WCHAR *key, const WCHAR *ValueName, const WCHAR *Value,val_type ValueType,long ValueLen)
{
     HKEY hkey;

     if (RegOpenKeyEx(root,key,0,KEY_SET_VALUE,&hkey)!=ERROR_SUCCESS)
     return false;

     if (RegSetValueEx(hkey,ValueName,0,ValueType,(BYTE*)Value,ValueLen*2)==ERROR_SUCCESS)
   return true;
   else
   return false;
}

bool DeleteValuereg(HKEY root, const WCHAR *key, const WCHAR *ValueName)
{
     HKEY hkey;
     LONG res;

     if (RegOpenKeyEx(root,key,0,KEY_WRITE,&hkey)!=ERROR_SUCCESS) return false;

     res=RegDeleteValue(hkey,ValueName);

     RegCloseKey(hkey);

     if (res==ERROR_SUCCESS)return true;
     else
     {
         return false;
     };


};
