//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unniticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef UNICODE
#define UNICODE
#endif

#ifndef WINDOWS
#define WINDOWS
#include<windows.h>
#endif

#ifndef SHLOBJ
#define SHLOBJ
#include <shlobj.h>
#endif

#ifndef STRINGR
#define STRINGR 
#include"StringR.h"
#endif

#ifndef CONVERTIONR
#define CONVERTIONR
#include"ConvertionR.h"
#endif
        // encapsulation of MessageBox
        void Smessage(const WCHAR *mess);
        void Smessage(const WCHAR *caption,const WCHAR *mess);
        void Smessage(HWND winhandle , const WCHAR *mess);
        void Smessage(const WCHAR ch);
        void Smessage(const char *ch);

        bool OpenFileDialog( WCHAR * res , ULONG ressize , WCHAR *filter , HWND win ); // ressize is the size of res including the ending zero
        bool SaveFileDialog( WCHAR * res , ULONG ressize , WCHAR *filter , HWND win ); // ressize is the size of res including the ending zero
        bool SelectFolderDialog( WCHAR * res , ULONG ressize , HWND win );
        bool SelectFileFolderDialog( WCHAR * res , ULONG ressize , HWND win );
        bool ItsFolder(WCHAR *path); // true if its folder false if its file

        void CopyMemoryM(char *dest,char *source,ULONG len);

        bool ExecTheFile(LPWSTR file,LPWSTR param);

        UINT Random(UINT range,unsigned char rseed);

        void ProccessMessages(HWND winhandle);//call this inside a loop to forward the messages that are waiting in the queue to the application

        int GetWindowState(HWND winhandle);

        short ReadSect(WCHAR* dsk , char* &buff , unsigned int sector); //reads a sector for a disk. Sectors are 512 bytes in size, so the buff must be 512 chars
        short WriteSect(WCHAR* dsk , char* buff,unsigned int sector);  //writes a sector for a disk. Sectors are 512 bytes in size, so the buff must be 512 chars

        WCHAR *GetDiskSerialStr(WCHAR disk);//disk=only letter!
        long GetDiskSerialLong(WCHAR disk);//disk=only letter!

        bool ChangeDiskSerialNumber( char disk, long serial); //disk = letter only serial = the new serial in number

        void ShutDownMachine();
        
        
        //code

void Smessage(const WCHAR *mess)
{
 MessageBox(NULL,mess,L"Message",MB_OK);
}

void Smessage(HWND winhandle,const WCHAR *mess)
{
    MessageBox(winhandle,mess,L"Message",MB_OK);
};

void Smessage(const WCHAR *caption,const WCHAR *mess)
{
 MessageBox(NULL,mess,caption,MB_OK);
}

void Smessage(const WCHAR ch)
{
    WCHAR *tmp=new WCHAR[2];
    tmp[0]=ch;
    tmp[1]=0;
    MessageBox(NULL,tmp,L"Message",MB_OK);

    delete [] tmp;

};

void Smessage(const char *mess)
{
  MessageBoxA(NULL,mess,"Message",MB_OK);
}



     bool OpenFileDialog( WCHAR * res , ULONG ressize , WCHAR *filter , HWND win )
    {
        OPENFILENAME ofn	= {0};
        ofn.hInstance		= NULL;
        ofn.hwndOwner		= win;
        ofn.lStructSize		= sizeof(OPENFILENAME);
        ofn.lpstrFilter		= filter;
        ofn.lpstrTitle		= L"Open File";
        ofn.lpstrFile		= res;
        ofn.nMaxFile		= ressize;
        ofn.Flags			= OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

       bool ret = GetOpenFileName(&ofn);

       return ret ;
    };

     bool SaveFileDialog( WCHAR * res , ULONG ressize , WCHAR *filter , HWND win )
     {
        OPENFILENAME ofn	= {0};
        ofn.hInstance		= NULL;
        ofn.hwndOwner		= win;
        ofn.lStructSize		= sizeof(OPENFILENAME);
        ofn.lpstrFilter		= filter;
        ofn.lpstrTitle		= L"Save File";
        ofn.lpstrFile		= res;
        ofn.nMaxFile		= ressize;
        ofn.Flags			= OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;

       bool ret = GetSaveFileName(&ofn);

       return ret ;
     };

     bool SelectFolderDialog( WCHAR * res , ULONG ressize , HWND win )
     {

        BROWSEINFO m_bi={0};
        WCHAR flname[MAX_PATH];
        flname[0]=0;
        m_bi.hwndOwner = win;
        m_bi.pidlRoot = NULL;
        m_bi.lpszTitle = L"Select Folder";
        m_bi.pszDisplayName = flname;
        m_bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE;
        m_bi.lpfn = NULL;

        LPITEMIDLIST pItemIDList = SHBrowseForFolder(&m_bi);

        if ( pItemIDList != 0 )
        {

            WCHAR path[MAX_PATH];
            if ( SHGetPathFromIDList ( pItemIDList, path ) )
            {
               ULONG ln = StrLen( path );
               CopyStr( res , path , ressize );
            }

            // free memory
            IMalloc * imalloc = 0;
            if ( SUCCEEDED( SHGetMalloc ( &imalloc )) )
            {
                imalloc->Free ( pItemIDList );
                imalloc->Release ( );
            }
            return true;
     };
     return false;
     };

      bool SelectFileFolderDialog( WCHAR * res , ULONG ressize , HWND win )
     {

        BROWSEINFO m_bi={0};
        WCHAR flname[MAX_PATH];
        flname[0]=0;
        m_bi.hwndOwner = win;
        m_bi.pidlRoot = NULL;
        m_bi.lpszTitle = L"Select File";
        m_bi.pszDisplayName = flname;
        m_bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_BROWSEINCLUDEFILES | BIF_NEWDIALOGSTYLE;
        m_bi.lpfn = NULL;

        LPITEMIDLIST pItemIDList = SHBrowseForFolder(&m_bi);

        if ( pItemIDList != 0 )
        {

            WCHAR path[MAX_PATH];
            if ( SHGetPathFromIDList ( pItemIDList, path ) )
            {
               ULONG ln = StrLen( path );

               CopyStr(res,path,ressize);
            }

            // free memory
            IMalloc * imalloc = 0;
            if ( SUCCEEDED( SHGetMalloc ( &imalloc )) )
            {
                imalloc->Free ( pItemIDList );
                imalloc->Release ( );
            }

            return true;
     };
     return false;
     };

      bool ItsFolder(WCHAR *path)
      {
           if ((GetFileAttributes(path) & FILE_ATTRIBUTE_DIRECTORY ) )
            return true;
            else
                return false;
      }


    void CopyMemoryM(char *dest, char *source, ULONG len)
    {
        if ((dest!=NULL)&&(source!=NULL))
        for (ULONG i=0;i<len;i++)
        {
          *dest=*source;
          dest++;
          source++;

        };

    }


bool ExecTheFile(LPWSTR file,LPWSTR param)
{

 if (ShellExecute(NULL,L"open",file,param,L"c:\\",SW_SHOWNORMAL)<=(HINSTANCE)32)
     return false;
     return true;

};

UINT Random(UINT range,unsigned char rseed)
{

     SYSTEMTIME tm;
     DWORD millisec1,millisec2,millisec3;
     DWORD temp=0;
     Sleep(1);
     millisec1=GetTickCount();

     GetSystemTime(&tm);

     millisec2= tm.wMilliseconds;

     if (millisec2==0)millisec2=1;
     Sleep((rseed%10)+1);
     GetSystemTime(&tm);
     millisec3=tm.wMilliseconds;
     temp=(DWORD)((millisec1 )/ millisec2)*millisec3;

     if (temp!=0)
     temp=temp % (range);

     return (UINT)temp;

}


   void ProccessMessages(HWND winhandle)
   {
           MSG messages;

           if (PeekMessage(&messages,winhandle, 0, 0, PM_REMOVE)==true)
           {
           TranslateMessage(&messages);
           DispatchMessage(&messages);
           };
   };


    int GetWindowState(HWND winhandle)
    {
        WINDOWPLACEMENT wintpl;
        wintpl.length=sizeof(WINDOWPLACEMENT);

        if (GetWindowPlacement(winhandle,&wintpl)==false) return -1;
        else return wintpl.showCmd;

    }

    WCHAR *GetDiskSerialStr(WCHAR disk)
    {
      DWORD NotUsed;
      DWORD VolumeFlags;
      DWORD VolumeSerialNumber;
      WCHAR dsk[4];
        dsk[0]=disk;
        dsk[1]=L':';
        dsk[2]=L'\\';
        dsk[3]=0;

        GetVolumeInformation(dsk,NULL, 0, &VolumeSerialNumber, &NotUsed,&VolumeFlags,NULL,0);
        return LongToStr(VolumeSerialNumber);


    };

     long GetDiskSerialLong(WCHAR disk)
    {
      DWORD NotUsed;
      DWORD VolumeFlags;
      DWORD VolumeSerialNumber;
      WCHAR dsk[4];
        dsk[0]=disk;
        dsk[1]=L':';
        dsk[2]=L'\\';
        dsk[3]=0;

        GetVolumeInformation(dsk,NULL, 0, &VolumeSerialNumber, &NotUsed,&VolumeFlags,NULL,0);
        return VolumeSerialNumber;


    };


//inefficient for consecutive operations because the disk handle is closed every time;
short ReadSect(WCHAR* dsk , char* &buff , unsigned int sector)
{


        DWORD dwRead;

        //open the disk

        HANDLE Disk=CreateFile(dsk,GENERIC_READ,FILE_SHARE_VALID_FLAGS,0,OPEN_EXISTING,0,0);

        if(Disk==INVALID_HANDLE_VALUE) // this may happen if another program is already reading from disk
          {
             CloseHandle(Disk);
             return 1;
          }

        SetFilePointer(Disk,sector*512,0,FILE_BEGIN); // which sector to read

       if  (ReadFile(Disk,buff,512,&dwRead,0)==false)
       {
           CloseHandle(Disk);
           return 1;
       };  // read sector
        CloseHandle(Disk);
        return 0;
}


//ineficient for consecutive operations because the disk handle is closed every time;
short WriteSect(WCHAR* dsk , char* buff , unsigned int sector)
{


       DWORD dwWrite;

        //open the disk

        HANDLE Disk=CreateFile(dsk,GENERIC_WRITE,FILE_SHARE_VALID_FLAGS,0,OPEN_EXISTING,0,0);

        if(Disk==INVALID_HANDLE_VALUE) // this may happen if another program is already reading from disk
          {
             CloseHandle(Disk);
             return 1;
          }

        SetFilePointer(Disk,sector*512,0,FILE_BEGIN); // which sector to overwrite

        if (WriteFile(Disk,buff,512,&dwWrite,0)==false)  // write sector
        {
           CloseHandle(Disk);
           return 1;
       };  // read sector
        CloseHandle(Disk);
        return 0;



}





     bool ChangeDiskSerialNumber( WCHAR disk, long serial)
     {

        //lets read the boot sector

        WCHAR dsk[7];

        //preparing the disk letter

        dsk[0]=L'\\';
        dsk[1]=L'\\';
        dsk[2]=L'.';
        dsk[3]=L'\\';
        dsk[4]=disk;
        dsk[5]=L':';
        dsk[6]=0;

        char *buff=new char[512];

        if (ReadSect(dsk,buff,0)==1) return false;


        int fs = 0; //filesystem 1 for fat32 2 for ntfs 0 for unsupported


         if (buff[82]=='F'&&buff[83]=='A'&&buff[84]=='T'&&buff[85]=='3'&&buff[86]=='2')
           fs=1;
            else
        if (buff[3]=='N'&&buff[4]=='T'&&buff[5]=='F'&&buff[6]=='S')
           fs=2;


           switch (fs)

           {

           case 1 :
                    {

                          long *test;
                          test=(long*)&buff[67];

                           *test=serial; //we are changing the buffer so it can have the new serial

                           if (WriteSect(dsk ,buff , 0)==1) return false; //writing the serial

                           break;


                    }

           case 2:
                    {

                          long *test;
                          test=(long*)&buff[72];


                           *test=serial; //we are changing the buffer so it can have the new serial

                          if (WriteSect(dsk ,buff , 0)==1) return false; //writing the serial

                          break;

                    }

                     default : return false;

           }




        return true;

     }

     void ShutDownMachine()
     {
          HANDLE   hToken;
          TOKEN_PRIVILEGES   tkp;

  //   Get   a   token   for   this   process.

  if   (!OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
  {
      Smessage(L"OpenProcessToken error");
      return;
  }


  LookupPrivilegeValue(NULL,   SE_SHUTDOWN_NAME,
                  &tkp.Privileges[0].Luid);

  tkp.PrivilegeCount   =   1;     //   one   privilege   to   set
  tkp.Privileges[0].Attributes   =   SE_PRIVILEGE_ENABLED;


  AdjustTokenPrivileges(hToken,   FALSE,   &tkp,   0,
                  (PTOKEN_PRIVILEGES)NULL,   0);


  if   (GetLastError()   !=   ERROR_SUCCESS)
  {
     Smessage(L"AdjustTokenPrivileges error");
     return;
  }


  if   (!ExitWindowsEx(EWX_SHUTDOWN   |   EWX_FORCE,   0))
  {
      Smessage(L"ExitWindowsEx error");
      return;

  }

     }





